/*****************************************************************************\
**                                                                           **
**  WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE  **
**  WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE        **
**  WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE        **
**    WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE  **
**                                                                           **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE  **
**  SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE        **
**   SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**       SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE        **
**  SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE  **
**                                                                           **
*********** NOTICE ************************************************************
**        This file contains valuable trade secrets and proprietary          **
**        assets of Windbase Software Inc.  Embodying substantial            **
**        creative efforts and confidential information.  Unauthorized       **
**        use, copying, decompiling, translating, disclosure or              **
**        transfer, of any kind, is strictly prohibited.                     **
**                                                                           **
**        COPYRIGHT (C) 1992, 1993, 1994.  Windbase Software Inc.            **
**        ALL RIGHTS RESERVED.                                               **
\*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>
#ifdef HAS_UNISTD_H
#  include <unistd.h>
#else
#  include <stdlib.h>
#endif

#include "../../memsl.h"

#define BUFFSIZE 512

WBDHASH *dhash;
WBSLIST *slist;
WBERROR *errhdl;

#ifndef strupr

#ifdef WBSTDC
  char *strupr(char *str)
#else
  char *strupr(str)
    char *str;
#endif
  {
    char *strptr = str;

    if (str)
      while (*str)
        {
          *str = toupper(*str);
          str++;
        }

    return(strptr);
  }

#endif

#ifdef WBSTDC
  void Search(void *nullitem, char *item)
#else
  void Search(nullitem, item)
    void *nullitem;
    char *item;
#endif
  {
    char *tmpstr;

    if (nullitem);

    tmpstr = WBDHashSearch(dhash,item);
    if (tmpstr == NULL)
      fprintf(stderr,"%c%s was lost\n",7,item);
  }

#ifdef WBSTDC
  int Compare(void *nullitem, char *item1, char *item2)
#else
  int Compare(nullitem, item1, item2)
    void *nullitem;
    char *item1;
    char *item2;
#endif
  {
    if (nullitem);
    return(strcmp(item1,item2));
  }

#ifdef WBSTDC
  void Delete(void *nullitem, void *item)
#else
  void Delete(nullitem, item)
    void *nullitem;
    void *item;
#endif
  {
    if (nullitem);
    free(item);
  }

#ifdef WBSTDC
  void InitTokens(char *tokens)
#else
  void InitTokens(tokens)
    char *tokens;
#endif
  {
    int i;

    memset(tokens,0,256);
    for (i = 0; i < 256; i++)
      if (!isalpha(i))
        *(tokens+strlen(tokens)) = (char) i;
  }

#ifdef WBSTDC
  void SpellCheck(WBDHASH *dhash, char *filename)
#else
  void SpellCheck(dhash, filename)
    WBDHASH *dhash;
    char *filename;
#endif
  {
    FILE *file;
    char str[256], tokens[256], wordstr[256], *strptr;
    long linenum = 1, lastline = 0;

    if ((file = fopen(filename,"rt")) != NULL)
      {
        InitTokens(tokens);
        while (fgets(str,255,file))
          {
            strptr = strtok(str,tokens);
            while (strptr)
              {
                strcpy(wordstr,strptr);
                strupr(strptr);
                if (WBDHashSearch(dhash,strptr) == 0)
                  {
                    if (lastline != linenum)
                      {
                        printf("\n%d:",linenum);
                        lastline = linenum;
                      }
                    printf(" %s",wordstr);
                  }
                strptr = strtok(NULL,tokens);
              }
            linenum++;
          }
        if (linenum)
          printf("\n");
        fclose(file);
      }
  }

#ifdef WBSTDC
  void InitHashing(WBDHASH *dhash)
#else
  void InitHashing(dhash)
    WBDHASH *dhash;
#endif
  {
    FILE *file;
    char *buff;
    int offset, numwords = 0, done = 0;

    fprintf(stderr,"Loading Dictionary ");
    if ((file = fopen("spell.dct","rb")) != NULL)
      {
        while (! done && !ferror(file) && !feof(file))
          {
            if ((buff = malloc(BUFFSIZE)) != NULL)
              {
                WBSListAdd(slist,buff,WB_LAST);
                memset(buff,0,BUFFSIZE);
                fread(buff,1,BUFFSIZE,file);
                offset = 0;
                fprintf(stderr,".");
                while (! done && offset < BUFFSIZE)
                  {
                    if (WBDHashAdd(dhash,buff+offset) == 0)
                      done = 1;
                    offset+=strlen(buff+offset);
                    while (offset < BUFFSIZE && *(buff+offset) == 0)
                      offset++;
                    numwords++;
                  }
              }
            else done = 1;
          }
        fclose(file);
      }
    fprintf(stderr,"Words in dictionary: %d\n",numwords);
  }

#ifdef WBSTDC
  int main(int argc, char **argv)
#else
  int main(argc, argv)
    int argc;
    char **argv;
#endif
  {
    if (argc != 2)
      {
        printf("Usage: spell filename\n");
        exit(1);
      }
    if ((slist = WBSListOpen(NULL)) != NULL)
      {
        WBSListDeleteF(slist,NULL,(void (*)())Delete);
        if ((dhash = WBDHashOpen(NULL,50)) != NULL)
          {
            WBDHashHashingF(dhash,NULL,WBHashFunct);
            WBDHashCompareF(dhash,NULL,(int (*)())Compare);
            WBDHashExecuteF(dhash,NULL,(void (*)())Search);
            InitHashing(dhash);
            SpellCheck(dhash,argv[1]);
            WBDHashClose(dhash);
          }
        WBSListClose(slist);
      }
    return(0);
  }
